<template>
  <div class="q-pa-md">
    <q-table
      title="Soft Bisect"
      class="no-shadow"
      :rows="rows"
      no-data-label="Soft Bisect data not available yet."
      :columns="columns"
      row-key="name"
      :filter="filter">

      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th auto-width />
          <q-th
            v-for="col in props.cols"
            :key="col.name"
            :props="props"
          >
            {{ col.label }}
          </q-th>
        </q-tr>
      </template>

      <template v-slot:body="props">
	<q-tr :props="props">
          <q-td auto-width>
            <q-icon name="fas fa-check" size="xs"  style="color: #21ba45;"/>
          </q-td>
          <q-td key="sha" :props="props">
              <a :href="props.row.web_url">{{ props.row.sha}}</a> <br> {{ props.row.title }} <br>by <i>{{ props.row.author }}</i><br>at {{ props.row.committed_date }}
          </q-td>
        </q-tr>
      </template>

    </q-table>
  </div>
</template>

<script>

import { ref } from 'vue'

const columns = [
  {
    name: 'sha',
    label: 'Commit',
    align: 'left',
    field: 'sha',
    sortable: true
  }
]

const rows = []


export default {
  props: ['bisect'],
  data () {
    return {
      filters: undefined,
      filter: ref(''),
      columns,
      rows,
      search: ''
    }
  },
  created () {
    this.rows = []
  },
  updated () {
    for (const [sha, commit] of Object.entries(this.bisect)) {
       console.log(commit)
       this.rows.push({'sha': commit['short_id'],
                       'author': commit['author_name'] + ' <' + commit['author_email'] + '>',
                       'title': commit['title'],
                       'web_url': commit['web_url'],
                       'committed_date': commit['committed_date']})
    }
    // for (const [key, value] of this.bisect.entries()) {
    //    this.rows.push({'sha': key, 'ref': value.ref})
    // }
  }
}
</script>

<style>
.q-mt-sm {
  margin-top: 2px !important;
  margin-left: 8px !important;
}

</style>
